/* SPDX-License-Identifier: MIT */
/*
 * Copyright (c) 2022-2023 NVIDIA CORPORATION & AFFILIATES. All rights reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

#ifndef T234_HWPM_PERFMON_DEVICE_INDEX_H
#define T234_HWPM_PERFMON_DEVICE_INDEX_H

enum t234_hwpm_perfmon_device_index {
	T234_VI0_PERFMON_DEVICE_NODE_INDEX,
	T234_VI1_PERFMON_DEVICE_NODE_INDEX,
	T234_ISP0_PERFMON_DEVICE_NODE_INDEX,
	T234_VICA0_PERFMON_DEVICE_NODE_INDEX,
	T234_OFAA0_PERFMON_DEVICE_NODE_INDEX,
	T234_PVAV0_PERFMON_DEVICE_NODE_INDEX,
	T234_PVAV1_PERFMON_DEVICE_NODE_INDEX,
	T234_PVAC0_PERFMON_DEVICE_NODE_INDEX,
	T234_NVDLAB0_PERFMON_DEVICE_NODE_INDEX,
	T234_NVDLAB1_PERFMON_DEVICE_NODE_INDEX,
	T234_NVDISPLAY0_PERFMON_DEVICE_NODE_INDEX,
	T234_SYS0_PERFMON_DEVICE_NODE_INDEX,
	T234_MGBE0_PERFMON_DEVICE_NODE_INDEX,
	T234_MGBE1_PERFMON_DEVICE_NODE_INDEX,
	T234_MGBE2_PERFMON_DEVICE_NODE_INDEX,
	T234_MGBE3_PERFMON_DEVICE_NODE_INDEX,
	T234_SCF_PERFMON_DEVICE_NODE_INDEX,
	T234_NVDECA0_PERFMON_DEVICE_NODE_INDEX,
	T234_NVENCA0_PERFMON_DEVICE_NODE_INDEX,
	T234_MSSNVLHSH0_PERFMON_DEVICE_NODE_INDEX,
	T234_PCIE0_PERFMON_DEVICE_NODE_INDEX,
	T234_PCIE1_PERFMON_DEVICE_NODE_INDEX,
	T234_PCIE2_PERFMON_DEVICE_NODE_INDEX,
	T234_PCIE3_PERFMON_DEVICE_NODE_INDEX,
	T234_PCIE4_PERFMON_DEVICE_NODE_INDEX,
	T234_PCIE5_PERFMON_DEVICE_NODE_INDEX,
	T234_PCIE6_PERFMON_DEVICE_NODE_INDEX,
	T234_PCIE7_PERFMON_DEVICE_NODE_INDEX,
	T234_PCIE8_PERFMON_DEVICE_NODE_INDEX,
	T234_PCIE9_PERFMON_DEVICE_NODE_INDEX,
	T234_PCIE10_PERFMON_DEVICE_NODE_INDEX,
	T234_MSS_CHANNEL_PARTA0_PERFMON_DEVICE_NODE_INDEX,
	T234_MSS_CHANNEL_PARTA1_PERFMON_DEVICE_NODE_INDEX,
	T234_MSS_CHANNEL_PARTA2_PERFMON_DEVICE_NODE_INDEX,
	T234_MSS_CHANNEL_PARTA3_PERFMON_DEVICE_NODE_INDEX,
	T234_MSS_CHANNEL_PARTB0_PERFMON_DEVICE_NODE_INDEX,
	T234_MSS_CHANNEL_PARTB1_PERFMON_DEVICE_NODE_INDEX,
	T234_MSS_CHANNEL_PARTB2_PERFMON_DEVICE_NODE_INDEX,
	T234_MSS_CHANNEL_PARTB3_PERFMON_DEVICE_NODE_INDEX,
	T234_MSS_CHANNEL_PARTC0_PERFMON_DEVICE_NODE_INDEX,
	T234_MSS_CHANNEL_PARTC1_PERFMON_DEVICE_NODE_INDEX,
	T234_MSS_CHANNEL_PARTC2_PERFMON_DEVICE_NODE_INDEX,
	T234_MSS_CHANNEL_PARTC3_PERFMON_DEVICE_NODE_INDEX,
	T234_MSS_CHANNEL_PARTD0_PERFMON_DEVICE_NODE_INDEX,
	T234_MSS_CHANNEL_PARTD1_PERFMON_DEVICE_NODE_INDEX,
	T234_MSS_CHANNEL_PARTD2_PERFMON_DEVICE_NODE_INDEX,
	T234_MSS_CHANNEL_PARTD3_PERFMON_DEVICE_NODE_INDEX,
	T234_MSSHUB0_PERFMON_DEVICE_NODE_INDEX,
	T234_MSSHUB1_PERFMON_DEVICE_NODE_INDEX,
	T234_MSSMCFCLIENT0_PERFMON_DEVICE_NODE_INDEX,
	T234_MSSMCFMEM0_PERFMON_DEVICE_NODE_INDEX,
	T234_MSSMCFMEM1_PERFMON_DEVICE_NODE_INDEX,
	T234_PMA_PERFMON_DEVICE_NODE_INDEX,
	T234_RTR_PERFMON_DEVICE_NODE_INDEX
};

#endif
